# Manuel technique

La section suivante détaille les choix et le fonctionnement techniques du module `LcvPrestaConnector`, ainsi que les données prisent en compte.



## Modes de fonctionnement

Le module possède deux modes :

1. le **mode basique** : dans le mode basique, le module crée les fiches produits et les données de base pour tous les produits déclarés comme publiés sur le site Internet. Quand une donnée autre qu'une donnée de stock ♜ *(essentiellement les stock, les prix et les promotions)* existe sur le backoffice LCV, elle est alors reportée/pré-créée dans Prestashop ; par la suite, si lors d'une synchronisation la donnée existe déjà sous Prestashop, celle-ci n'est pas touchée et la donnée reste inchangée ;
2. le **mode complet** : dans le mode complet, le module crée et tiens les fiches produits à jour pour tous les produits déclarés comme publiés sur le site Internet. Quand une donnée existe sur le backoffice LCV, elle est reportée dans Prestashop ; par la suite, si lors d'une synchronisation la donnée existe déjà sous Prestashop, celle-ci est écrasée par la valeur de LCV ;
3. **dans les deux modes**, le module aspire et tient à jour toutes les données de stock ♜ disponibles mises à disposition par LCV, que les produits soient publiés ou non sur le site Internet. Cela permet de gérer simplement le stock d'anciennes références pré-existantes sous Prestashop sans que le module les recrée.

*Note : les données marquées d'une tour (♜) désigne les données de stock. Ces données sont toujours écrasées par le module si elles existent sous Polaris.*



## Données synchronisées

### Produits

Fonctionnement général :

- sur LCV, certaines déclinaisons peuvent être discriminantes (par exemple, la couleur ou la matière), d'autres peuvent être des tailles (longueurs de jambe, bonnets, ...) ;
- chaque couple `{produit - déclinaisons discriminantes}` de LCV qui est marqué pour être sur Internet provoque la création et l'entretien d'un produit sous Prestashop ;
- dans ce produit Prestashop, chaque couple `{article - déclinaisons de taille}` de LCV provoque la création d'une déclinaison unique lorsque celle-ci n'existe pas déjà ;
- **la clé de synchronisation (la donnée utilisée pour reconnaître l'entité) est le code-barre LCV de l'article, injecté dans la référence fournisseur du produit, pour le fournisseur nommé `LCV`.** 

#### Données synchronisée sur le produit

*Quand la donnée n'est pas présente dans la colonne Prestashop, alors c'est que la donnée n'est pas synchronisée.*

| Donnée Prestashop                        | Notes                                                        |
| ---------------------------------------- | ------------------------------------------------------------ |
| Référence produit                        | La référence utilisée est la référence produit sous LCV concaténée aux libellés des déclinaisons discriminantes, séparées par le caractère `/`. |
| Référence fournisseur du fournisseur LCV | Le code barre LCV est utilisé ici comme clé de synchronisation. A ce niveau, on utilise l'un des codes barres des articles ; n'importe lequel. |
| Nom                                      | —                                                            |
| Marque                                   | —                                                            |
| Taux de taxes (TVA)                      | —                                                            |
| Écotaxe                                  | —                                                            |
| Description                              | —                                                            |
| Description Méta                         | —                                                            |
| Largeur, hauteur, profondeur, poids      | —                                                            |
| Prix de vente de base                    | Le prix de vente de base est le prix le plus bas, toutes déclinaisons et tailles confondues. |
| Caractéristiques                         | Les caractéristiques sont définies par mappages de champs dynamiques dans LCV ; voir la configuration pour plus de détails. |
| Catégories                               | Les catégories sont définies par mappage des `Rayons` et des `Familles` LCV. |
| Photos                                   |                                                              |

#### Données synchronisée sur la déclinaison

*Quand la donnée n'est pas présente dans la colonne Prestashop, alors c'est que la donnée n'est pas synchronisée.*

| Donnée Prestashop                        | Notes                                                        |
| ---------------------------------------- | ------------------------------------------------------------ |
| Référence de la déclinaison              | C'est le code-barre LCV qui est utilisé ici.                 |
| Référence fournisseur du fournisseur LCV | Le code barre LCV est utilisé ici comme clé de synchronisation. |
| Attributs constituants la déclinaison    | Les déclinaisons non-discriminantes et les tailles LCV sont utilisées pour créer les déclinaisons Prestashop. |
| Prix de vente                            | Prix de vente en boutique.                                   |
| Code barre EAN13                         | Code barre fournisseur sous LCV                              |
| ~~Emplacement du stock~~                 | Non synchronisé sur cette version.                           |
| Association de photo                     | Le module rétablit les bonnes photos avec les bonnes déclinaisons automatiquement. |



### Marques



### Caractéristiques



### Tailles



### Groupes d'attributs



### Catégories



### Stock (♜)



### Promotions (♜)
