<?php
namespace PrestaShop\Module\LCVPrestaConnector;

/**
 * Interface de pont
 */
abstract class BridgeAdapter
{
    /**
     * Configuration du module
     */
    protected SyncConfiguration $config;

    /**
     * Constructeur
     */
    public function __construct(SyncConfiguration $config)
    {
        $this->config = $config;
    }

    /**
     * Renvoi l'identifiant du pont correspondant au backoffice géré
     */
    public abstract function getId() : string;

    /**
     * Teste la connexion au backoffice avec les paramètres fournis.
     * Renvoi null quand la connexion a été effectuée correctement,
     * autrement, renvoi l'erreur.
     */
    public abstract function testConnect($args) : string|null;
}
